<template>
  <section class="section">
    <div class="columns">
      <div class="column is-4 is-offset-4">
        <h1 class="title"><AccountIcon />Login</h1>
        <form @submit.prevent="login">
          <div class="field">
            <label class="label">Email <MenuIcon /></label>
            <div class="control">
              <input class="input is-medium"
                v-bind:class="{ 'is-danger': error }"
                v-model.trim="email" placeholder="email">
            </div>
          </div>
          <div class="field">
            <label class="label">Password</label>
            <div class="control">
              <input class="input is-medium" 
                v-bind:class="{ 'is-danger': error }"
                v-model.trim="password" placeholder="password" type="password">
            </div>
          </div>
          <button class="button is-primary is-large" type="submit">Login</button>
        </form>
      </div>
    </div>
  </section>
</template>

<script>
import MenuIcon from "icons/Menu.vue";
import AccountIcon from "icons/Account.vue";

export default {
  components: {
    MenuIcon,
    AccountIcon
  },
  data() {
    return {
      email: "",
      password: ""
    };
  },
  computed: {
    authStatus() {
      return this.$store.getters.authStatus;
    },
    error() {
      if (this.$store.getters.authStatus === "error") {
        return "is_error";
      }
    }
  },
  methods: {
    login() {
      const { email, password } = this;

      this.$store
        .dispatch("AUTH_REQUEST", { email, password })
        .then(() => {
          this.$router.push("/");
          this.$toast.open({
            duration: 5000,
            message: `Welcome back!`,
            type: `is-success`
          });
        })
        .catch(() => {
          this.$toast.open({
            duration: 5000,
            message: `Incorrect email or password`,
            type: `is-danger`
          });
        });
    }
  }
};
</script>

<style>
</style>
